<template>
    <div class="layout-center">
        <div class="layout-border" style="background: rgb(255, 255, 255); padding: 24px">
            <a-typography-title :level="3" :style="{ marginBottom: 42 }">Forgot Password</a-typography-title>
            <a-form
                :label-col="{ style: { width: '30%', textAlign: 'left' } }"
                :wrapper-col="{ style: { width: '40%' } }"
                :model="formState"
                name="normal_login"
                class="login-form"
                @finish="onFinish"
                @finishFailed="onFinishFailed"
                :style="{ width: '400px' }"
            >
                <a-form-item label="Email" name="email" :rules="[
                        { required: true, message: 'Please input your email!' },
                        { type: 'email', message: 'Email Invalid' },
                    ]">
                    <a-input placeholder="input your email" v-model:value="formState.email">
                    </a-input>
                </a-form-item>

                <a-typography-text type="danger" v-if="errors">*{{ errors }}</a-typography-text>

                <div :style="{ display: 'flex', justifyContent: 'space-between', alignItems: 'flex-start', marginTop: '36px' }">
                    <a-form-item>
                        <a-button type="primary" html-type="submit" class="login-form-button"> Send request </a-button>
                        Or
                        <a-typography-link underline href="/login">login now!</a-typography-link>
                    </a-form-item>
                </div>
            </a-form>
        </div>
    </div>
</template>
<script lang="ts" setup>
import { reactive } from "vue";
import { message } from "ant-design-vue";


const authStore = useAuthStore();
const userStore = useUserStore();
const { isLoaded } = storeToRefs(userStore);


let errors = ref<string | null>(null);

interface FormState {
    email: string;
}

const formState = reactive<FormState>({
    email: "",
});

const onFinish = async () => {
    errors.value = null;
    isLoaded.value = true;
    try {
        await authStore.forgotPassword(formState.email);
        formState.email = "";
        message.success("Reset password link sent to your email");
    } catch (error: any) {
        errors.value = error.response.data.message;
    
    } finally {
        isLoaded.value = false;
    }
};

const onFinishFailed = () => {
    console.log("onFinishFailed");
};
</script>

<style scoped>
.layout-center {
    display: flex;
    justify-content: center;
    align-items: center;
    height: 100vh;
}
</style>
